Index: /branches/UKMO/dev_3841_sbc/NEMOGCM/NEMO/OPA_SRC/SBC/sbccpl.F90
===================================================================
--- /branches/UKMO/dev_3841_sbc/NEMOGCM/NEMO/OPA_SRC/SBC/sbccpl.F90	(revision 4826)
+++ /branches/UKMO/dev_3841_sbc/NEMOGCM/NEMO/OPA_SRC/SBC/sbccpl.F90	(revision 4827)
@@ -795,5 +546,5 @@
       !                                                      ! ========================= !
       !
-      IF( .NOT. srcv(jpr_w10m)%laction ) THEN                    ! compute wind spreed from wind stress module if not received  
+      IF( .NOT. sf(jp_w10m)%loasis ) THEN                    ! compute wind spreed from wind stress module if not received  
          ! => need to be done only when taumod was changed
          IF( llnewtau ) THEN 
@@ -803,10 +554,10 @@
 !CDIR NOVERRCHK
                DO ji = 1, jpi 
-                  wndm(ji,jj) = SQRT( frcv(jpr_taum)%z3(ji,jj,1) * zcoef )
+                  wndm(ji,jj) = SQRT( sf(jp_taum)%fnow(ji,jj,1) * zcoef )
                END DO
             END DO
          ENDIF
       ELSE
-         IF ( nrcvinfo(jpr_w10m) == OASIS_Rcv ) wndm(:,:) = frcv(jpr_w10m)%z3(:,:,1)
+         IF ( sf(jp_w10m)%ninfo == OASIS_Rcv ) wndm(:,:) = sf(jp_w10m)%fnow(:,:,1)
       ENDIF
 
@@ -815,7 +566,7 @@
       IF( MOD( kt-1, k_fsbc ) == 0 ) THEN
          !
-         utau(:,:) = frcv(jpr_otx1)%z3(:,:,1)
-         vtau(:,:) = frcv(jpr_oty1)%z3(:,:,1)
-         taum(:,:) = frcv(jpr_taum)%z3(:,:,1)
+         utau(:,:) = sf(jp_otx1)%fnow(:,:,1)
+         vtau(:,:) = sf(jp_oty1)%fnow(:,:,1)
+         taum(:,:) = sf(jp_taum)%fnow(:,:,1)
          CALL iom_put( "taum_oce", taum )   ! output wind stress module
          !  
@@ -824,5 +575,5 @@
 #if defined key_cpl_carbon_cycle
       !                                                              ! atmosph. CO2 (ppm)
-      IF( srcv(jpr_co2)%laction )   atm_co2(:,:) = frcv(jpr_co2)%z3(:,:,1)
+      IF( sf(jp_co2)%loasis )   atm_co2(:,:) = sf(jp_co2)%fnow(:,:,1)
 #endif
 
@@ -834,7 +585,7 @@
          SELECT CASE( TRIM( sn_rcv_emp%cldes ) )                                    ! evaporation - precipitation
          CASE( 'conservative' )
-            emp(:,:) = frcv(jpr_tevp)%z3(:,:,1) - ( frcv(jpr_rain)%z3(:,:,1) + frcv(jpr_snow)%z3(:,:,1) )
+            emp(:,:) = sf(jp_tevp)%fnow(:,:,1) - ( sf(jp_rain)%fnow(:,:,1) + sf(jp_snow)%fnow(:,:,1) )
          CASE( 'oce only', 'oce and ice' )
-            emp(:,:) = frcv(jpr_oemp)%z3(:,:,1)
+            emp(:,:) = sf(jp_oemp)%fnow(:,:,1)
          CASE default
             CALL ctl_stop( 'sbc_cpl_rcv: wrong definition of sn_rcv_emp%cldes' )
@@ -842,6 +593,6 @@
          !
          !                                                        ! runoffs and calving (added in emp)
-         IF( srcv(jpr_rnf)%laction )   emp(:,:) = emp(:,:) - frcv(jpr_rnf)%z3(:,:,1)
-         IF( srcv(jpr_cal)%laction )   emp(:,:) = emp(:,:) - frcv(jpr_cal)%z3(:,:,1)
+         IF( sf(jp_rnf)%loasis )   emp(:,:) = emp(:,:) - sf(jp_rnf)%fnow(:,:,1)
+         IF( sf(jp_cal)%loasis )   emp(:,:) = emp(:,:) - sf(jp_cal)%fnow(:,:,1)
          !
 !!gm :  this seems to be internal cooking, not sure to need that in a generic interface 
@@ -849,29 +600,29 @@
 !!         IF( TRIM( sn_rcv_rnf%cldes ) == 'coupled' ) THEN     ! add to the total freshwater budget
 !!            ! remove negative runoff
-!!            zcumulpos = SUM( MAX( frcv(jpr_rnf)%z3(:,:,1), 0.e0 ) * e1t(:,:) * e2t(:,:) * tmask_i(:,:) ) 
-!!            zcumulneg = SUM( MIN( frcv(jpr_rnf)%z3(:,:,1), 0.e0 ) * e1t(:,:) * e2t(:,:) * tmask_i(:,:) )
+!!            zcumulpos = SUM( MAX( sf(jp_rnf)%fnow(:,:,1), 0.e0 ) * e1t(:,:) * e2t(:,:) * tmask_i(:,:) ) 
+!!            zcumulneg = SUM( MIN( sf(jp_rnf)%fnow(:,:,1), 0.e0 ) * e1t(:,:) * e2t(:,:) * tmask_i(:,:) )
 !!            IF( lk_mpp )   CALL mpp_sum( zcumulpos )   ! sum over the global domain
 !!            IF( lk_mpp )   CALL mpp_sum( zcumulneg ) 
 !!            IF( zcumulpos /= 0. ) THEN                 ! distribute negative runoff on positive runoff grid points
 !!               zcumulneg = 1.e0 + zcumulneg / zcumulpos
-!!               frcv(jpr_rnf)%z3(:,:,1) = MAX( frcv(jpr_rnf)%z3(:,:,1), 0.e0 ) * zcumulneg
+!!               sf(jp_rnf)%fnow(:,:,1) = MAX( sf(jp_rnf)%fnow(:,:,1), 0.e0 ) * zcumulneg
 !!            ENDIF     
 !!            ! add runoff to e-p 
-!!            emp(:,:) = emp(:,:) - frcv(jpr_rnf)%z3(:,:,1)
+!!            emp(:,:) = emp(:,:) - sf(jp_rnf)%fnow(:,:,1)
 !!         ENDIF
 !!gm  end of internal cooking
          !
          !                                                       ! non solar heat flux over the ocean (qns)
-         IF( srcv(jpr_qnsoce)%laction )   qns(:,:) = frcv(jpr_qnsoce)%z3(:,:,1)
-         IF( srcv(jpr_qnsmix)%laction )   qns(:,:) = frcv(jpr_qnsmix)%z3(:,:,1)
+         IF( sf(jp_qnsoce)%loasis )   qns(:,:) = sf(jp_qnsoce)%fnow(:,:,1)
+         IF( sf(jp_qnsmix)%loasis )   qns(:,:) = sf(jp_qnsmix)%fnow(:,:,1)
          ! add the latent heat of solid precip. melting
-         IF( srcv(jpr_snow  )%laction )   THEN                         ! update qns over the free ocean with:
-              qns(:,:) = qns(:,:) - frcv(jpr_snow)%z3(:,:,1) * lfus  & ! energy for melting solid precipitation over the free ocean
+         IF( sf(jp_snow  )%loasis )   THEN                         ! update qns over the free ocean with:
+              qns(:,:) = qns(:,:) - sf(jp_snow)%fnow(:,:,1) * lfus  & ! energy for melting solid precipitation over the free ocean
            &           - emp(:,:) * sst_m(:,:) * rcp                   ! remove heat content due to mass flux (assumed to be at SST)
          ENDIF
 
          !                                                       ! solar flux over the ocean          (qsr)
-         IF( srcv(jpr_qsroce)%laction )   qsr(:,:) = frcv(jpr_qsroce)%z3(:,:,1)
-         IF( srcv(jpr_qsrmix)%laction )   qsr(:,:) = frcv(jpr_qsrmix)%z3(:,:,1)
+         IF( sf(jp_qsroce)%loasis )   qsr(:,:) = sf(jp_qsroce)%fnow(:,:,1)
+         IF( sf(jp_qsrmix)%loasis )   qsr(:,:) = sf(jp_qsrmix)%fnow(:,:,1)
          IF( ln_dm2dc )   qsr(:,:) = sbc_dcy( qsr )                           ! modify qsr to include the diurnal cycle
          !
@@ -931,27 +682,27 @@
       CALL wrk_alloc( jpi,jpj, ztx, zty )
 
-      IF( srcv(jpr_itx1)%laction ) THEN   ;   itx =  jpr_itx1   
-      ELSE                                ;   itx =  jpr_otx1
+      IF( sf(jp_itx1)%loasis ) THEN   ;   itx =  jp_itx1   
+      ELSE                                ;   itx =  jp_otx1
       ENDIF
 
       ! do something only if we just received the stress from atmosphere
-      IF(  nrcvinfo(itx) == OASIS_Rcv ) THEN
+      IF(  sf(itx)%ninfo == OASIS_Rcv ) THEN
 
          !                                                      ! ======================= !
-         IF( srcv(jpr_itx1)%laction ) THEN                      !   ice stress received   !
+         IF( sf(jp_itx1)%loasis ) THEN                      !   ice stress received   !
             !                                                   ! ======================= !
             !  
             IF( TRIM( sn_rcv_tau%clvref ) == 'cartesian' ) THEN            ! 2 components on the sphere
                !                                                       ! (cartesian to spherical -> 3 to 2 components)
-               CALL geo2oce(  frcv(jpr_itx1)%z3(:,:,1), frcv(jpr_ity1)%z3(:,:,1), frcv(jpr_itz1)%z3(:,:,1),   &
-                  &          srcv(jpr_itx1)%clgrid, ztx, zty )
-               frcv(jpr_itx1)%z3(:,:,1) = ztx(:,:)   ! overwrite 1st comp. on the 1st grid
-               frcv(jpr_ity1)%z3(:,:,1) = zty(:,:)   ! overwrite 2nd comp. on the 1st grid
+               CALL geo2oce(  sf(jp_itx1)%fnow(:,:,1), sf(jp_ity1)%fnow(:,:,1), sf(jp_itz1)%fnow(:,:,1),   &
+                  &          sf(jp_itx1)%clvgrd, ztx, zty )
+               sf(jp_itx1)%fnow(:,:,1) = ztx(:,:)   ! overwrite 1st comp. on the 1st grid
+               sf(jp_ity1)%fnow(:,:,1) = zty(:,:)   ! overwrite 2nd comp. on the 1st grid
                !
-               IF( srcv(jpr_itx2)%laction ) THEN
-                  CALL geo2oce( frcv(jpr_itx2)%z3(:,:,1), frcv(jpr_ity2)%z3(:,:,1), frcv(jpr_itz2)%z3(:,:,1),   &
-                     &          srcv(jpr_itx2)%clgrid, ztx, zty )
-                  frcv(jpr_itx2)%z3(:,:,1) = ztx(:,:)   ! overwrite 1st comp. on the 2nd grid
-                  frcv(jpr_ity2)%z3(:,:,1) = zty(:,:)   ! overwrite 2nd comp. on the 2nd grid
+               IF( sf(jp_itx2)%loasis ) THEN
+                  CALL geo2oce( sf(jp_itx2)%fnow(:,:,1), sf(jp_ity2)%fnow(:,:,1), sf(jp_itz2)%fnow(:,:,1),   &
+                     &          sf(jp_itx2)%clvgrd, ztx, zty )
+                  sf(jp_itx2)%fnow(:,:,1) = ztx(:,:)   ! overwrite 1st comp. on the 2nd grid
+                  sf(jp_ity2)%fnow(:,:,1) = zty(:,:)   ! overwrite 2nd comp. on the 2nd grid
                ENDIF
                !
@@ -960,18 +711,18 @@
             IF( TRIM( sn_rcv_tau%clvor ) == 'eastward-northward' ) THEN   ! 2 components oriented along the local grid
                !                                                       ! (geographical to local grid -> rotate the components)
-               CALL rot_rep( frcv(jpr_itx1)%z3(:,:,1), frcv(jpr_ity1)%z3(:,:,1), srcv(jpr_itx1)%clgrid, 'en->i', ztx )   
-               IF( srcv(jpr_itx2)%laction ) THEN
-                  CALL rot_rep( frcv(jpr_itx2)%z3(:,:,1), frcv(jpr_ity2)%z3(:,:,1), srcv(jpr_itx2)%clgrid, 'en->j', zty )   
+               CALL rot_rep( sf(jp_itx1)%fnow(:,:,1), sf(jp_ity1)%fnow(:,:,1), sf(jp_itx1)%clvgrd, 'en->i', ztx )   
+               IF( sf(jp_itx2)%loasis ) THEN
+                  CALL rot_rep( sf(jp_itx2)%fnow(:,:,1), sf(jp_ity2)%fnow(:,:,1), sf(jp_itx2)%clvgrd, 'en->j', zty )   
                ELSE
-                  CALL rot_rep( frcv(jpr_itx1)%z3(:,:,1), frcv(jpr_ity1)%z3(:,:,1), srcv(jpr_itx1)%clgrid, 'en->j', zty )  
+                  CALL rot_rep( sf(jp_itx1)%fnow(:,:,1), sf(jp_ity1)%fnow(:,:,1), sf(jp_itx1)%clvgrd, 'en->j', zty )  
                ENDIF
-               frcv(jpr_itx1)%z3(:,:,1) = ztx(:,:)      ! overwrite 1st component on the 1st grid
-               frcv(jpr_ity1)%z3(:,:,1) = zty(:,:)      ! overwrite 2nd component on the 1st grid
+               sf(jp_itx1)%fnow(:,:,1) = ztx(:,:)      ! overwrite 1st component on the 1st grid
+               sf(jp_ity1)%fnow(:,:,1) = zty(:,:)      ! overwrite 2nd component on the 1st grid
             ENDIF
             !                                                   ! ======================= !
          ELSE                                                   !     use ocean stress    !
             !                                                   ! ======================= !
-            frcv(jpr_itx1)%z3(:,:,1) = frcv(jpr_otx1)%z3(:,:,1)
-            frcv(jpr_ity1)%z3(:,:,1) = frcv(jpr_oty1)%z3(:,:,1)
+            sf(jp_itx1)%fnow(:,:,1) = sf(jp_otx1)%fnow(:,:,1)
+            sf(jp_ity1)%fnow(:,:,1) = sf(jp_oty1)%fnow(:,:,1)
             !
          ENDIF
@@ -992,10 +743,10 @@
             !
          CASE( 'I' )                                         ! B-grid ==> I
-            SELECT CASE ( srcv(jpr_itx1)%clgrid )
+            SELECT CASE ( sf(jp_itx1)%clvgrd )
             CASE( 'U' )
                DO jj = 2, jpjm1                                   ! (U,V) ==> I
                   DO ji = 2, jpim1   ! NO vector opt.
-                     p_taui(ji,jj) = 0.5 * ( frcv(jpr_itx1)%z3(ji-1,jj  ,1) + frcv(jpr_itx1)%z3(ji-1,jj-1,1) )
-                     p_tauj(ji,jj) = 0.5 * ( frcv(jpr_ity1)%z3(ji  ,jj-1,1) + frcv(jpr_ity1)%z3(ji-1,jj-1,1) )
+                     p_taui(ji,jj) = 0.5 * ( sf(jp_itx1)%fnow(ji-1,jj  ,1) + sf(jp_itx1)%fnow(ji-1,jj-1,1) )
+                     p_tauj(ji,jj) = 0.5 * ( sf(jp_ity1)%fnow(ji  ,jj-1,1) + sf(jp_ity1)%fnow(ji-1,jj-1,1) )
                   END DO
                END DO
@@ -1003,6 +754,6 @@
                DO jj = 2, jpjm1                                   ! F ==> I
                   DO ji = 2, jpim1   ! NO vector opt.
-                     p_taui(ji,jj) = frcv(jpr_itx1)%z3(ji-1,jj-1,1)
-                     p_tauj(ji,jj) = frcv(jpr_ity1)%z3(ji-1,jj-1,1)
+                     p_taui(ji,jj) = sf(jp_itx1)%fnow(ji-1,jj-1,1)
+                     p_tauj(ji,jj) = sf(jp_ity1)%fnow(ji-1,jj-1,1)
                   END DO
                END DO
@@ -1010,25 +761,25 @@
                DO jj = 2, jpjm1                                   ! T ==> I
                   DO ji = 2, jpim1   ! NO vector opt.
-                     p_taui(ji,jj) = 0.25 * ( frcv(jpr_itx1)%z3(ji,jj  ,1) + frcv(jpr_itx1)%z3(ji-1,jj  ,1)   &
-                        &                   + frcv(jpr_itx1)%z3(ji,jj-1,1) + frcv(jpr_itx1)%z3(ji-1,jj-1,1) ) 
-                     p_tauj(ji,jj) = 0.25 * ( frcv(jpr_ity1)%z3(ji,jj  ,1) + frcv(jpr_ity1)%z3(ji-1,jj  ,1)   &
-                        &                   + frcv(jpr_oty1)%z3(ji,jj-1,1) + frcv(jpr_ity1)%z3(ji-1,jj-1,1) )
+                     p_taui(ji,jj) = 0.25 * ( sf(jp_itx1)%fnow(ji,jj  ,1) + sf(jp_itx1)%fnow(ji-1,jj  ,1)   &
+                        &                   + sf(jp_itx1)%fnow(ji,jj-1,1) + sf(jp_itx1)%fnow(ji-1,jj-1,1) ) 
+                     p_tauj(ji,jj) = 0.25 * ( sf(jp_ity1)%fnow(ji,jj  ,1) + sf(jp_ity1)%fnow(ji-1,jj  ,1)   &
+                        &                   + sf(jp_oty1)%fnow(ji,jj-1,1) + sf(jp_ity1)%fnow(ji-1,jj-1,1) )
                   END DO
                END DO
             CASE( 'I' )
-               p_taui(:,:) = frcv(jpr_itx1)%z3(:,:,1)                   ! I ==> I
-               p_tauj(:,:) = frcv(jpr_ity1)%z3(:,:,1)
+               p_taui(:,:) = sf(jp_itx1)%fnow(:,:,1)                   ! I ==> I
+               p_tauj(:,:) = sf(jp_ity1)%fnow(:,:,1)
             END SELECT
-            IF( srcv(jpr_itx1)%clgrid /= 'I' ) THEN 
+            IF( sf(jp_itx1)%clvgrd /= 'I' ) THEN 
                CALL lbc_lnk( p_taui, 'I',  -1. )   ;   CALL lbc_lnk( p_tauj, 'I',  -1. )
             ENDIF
             !
          CASE( 'F' )                                         ! B-grid ==> F
-            SELECT CASE ( srcv(jpr_itx1)%clgrid )
+            SELECT CASE ( sf(jp_itx1)%clvgrd )
             CASE( 'U' )
                DO jj = 2, jpjm1                                   ! (U,V) ==> F
                   DO ji = fs_2, fs_jpim1   ! vector opt.
-                     p_taui(ji,jj) = 0.5 * ( frcv(jpr_itx1)%z3(ji,jj,1) + frcv(jpr_itx1)%z3(ji  ,jj+1,1) )
-                     p_tauj(ji,jj) = 0.5 * ( frcv(jpr_ity1)%z3(ji,jj,1) + frcv(jpr_ity1)%z3(ji+1,jj  ,1) )
+                     p_taui(ji,jj) = 0.5 * ( sf(jp_itx1)%fnow(ji,jj,1) + sf(jp_itx1)%fnow(ji  ,jj+1,1) )
+                     p_tauj(ji,jj) = 0.5 * ( sf(jp_ity1)%fnow(ji,jj,1) + sf(jp_ity1)%fnow(ji+1,jj  ,1) )
                   END DO
                END DO
@@ -1036,6 +787,6 @@
                DO jj = 2, jpjm1                                   ! I ==> F
                   DO ji = 2, jpim1   ! NO vector opt.
-                     p_taui(ji,jj) = frcv(jpr_itx1)%z3(ji+1,jj+1,1)
-                     p_tauj(ji,jj) = frcv(jpr_ity1)%z3(ji+1,jj+1,1)
+                     p_taui(ji,jj) = sf(jp_itx1)%fnow(ji+1,jj+1,1)
+                     p_tauj(ji,jj) = sf(jp_ity1)%fnow(ji+1,jj+1,1)
                   END DO
                END DO
@@ -1043,28 +794,28 @@
                DO jj = 2, jpjm1                                   ! T ==> F
                   DO ji = 2, jpim1   ! NO vector opt.
-                     p_taui(ji,jj) = 0.25 * ( frcv(jpr_itx1)%z3(ji,jj  ,1) + frcv(jpr_itx1)%z3(ji+1,jj  ,1)   &
-                        &                   + frcv(jpr_itx1)%z3(ji,jj+1,1) + frcv(jpr_itx1)%z3(ji+1,jj+1,1) ) 
-                     p_tauj(ji,jj) = 0.25 * ( frcv(jpr_ity1)%z3(ji,jj  ,1) + frcv(jpr_ity1)%z3(ji+1,jj  ,1)   &
-                        &                   + frcv(jpr_ity1)%z3(ji,jj+1,1) + frcv(jpr_ity1)%z3(ji+1,jj+1,1) )
+                     p_taui(ji,jj) = 0.25 * ( sf(jp_itx1)%fnow(ji,jj  ,1) + sf(jp_itx1)%fnow(ji+1,jj  ,1)   &
+                        &                   + sf(jp_itx1)%fnow(ji,jj+1,1) + sf(jp_itx1)%fnow(ji+1,jj+1,1) ) 
+                     p_tauj(ji,jj) = 0.25 * ( sf(jp_ity1)%fnow(ji,jj  ,1) + sf(jp_ity1)%fnow(ji+1,jj  ,1)   &
+                        &                   + sf(jp_ity1)%fnow(ji,jj+1,1) + sf(jp_ity1)%fnow(ji+1,jj+1,1) )
                   END DO
                END DO
             CASE( 'F' )
-               p_taui(:,:) = frcv(jpr_itx1)%z3(:,:,1)                   ! F ==> F
-               p_tauj(:,:) = frcv(jpr_ity1)%z3(:,:,1)
+               p_taui(:,:) = sf(jp_itx1)%fnow(:,:,1)                   ! F ==> F
+               p_tauj(:,:) = sf(jp_ity1)%fnow(:,:,1)
             END SELECT
-            IF( srcv(jpr_itx1)%clgrid /= 'F' ) THEN 
+            IF( sf(jp_itx1)%clvgrd /= 'F' ) THEN 
                CALL lbc_lnk( p_taui, 'F',  -1. )   ;   CALL lbc_lnk( p_tauj, 'F',  -1. )
             ENDIF
             !
          CASE( 'C' )                                         ! C-grid ==> U,V
-            SELECT CASE ( srcv(jpr_itx1)%clgrid )
+            SELECT CASE ( sf(jp_itx1)%clvgrd )
             CASE( 'U' )
-               p_taui(:,:) = frcv(jpr_itx1)%z3(:,:,1)                   ! (U,V) ==> (U,V)
-               p_tauj(:,:) = frcv(jpr_ity1)%z3(:,:,1)
+               p_taui(:,:) = sf(jp_itx1)%fnow(:,:,1)                   ! (U,V) ==> (U,V)
+               p_tauj(:,:) = sf(jp_ity1)%fnow(:,:,1)
             CASE( 'F' )
                DO jj = 2, jpjm1                                   ! F ==> (U,V)
                   DO ji = fs_2, fs_jpim1   ! vector opt.
-                     p_taui(ji,jj) = 0.5 * ( frcv(jpr_itx1)%z3(ji,jj,1) + frcv(jpr_itx1)%z3(ji  ,jj-1,1) )
-                     p_tauj(ji,jj) = 0.5 * ( frcv(jpr_ity1)%z3(jj,jj,1) + frcv(jpr_ity1)%z3(ji-1,jj  ,1) )
+                     p_taui(ji,jj) = 0.5 * ( sf(jp_itx1)%fnow(ji,jj,1) + sf(jp_itx1)%fnow(ji  ,jj-1,1) )
+                     p_tauj(ji,jj) = 0.5 * ( sf(jp_ity1)%fnow(jj,jj,1) + sf(jp_ity1)%fnow(ji-1,jj  ,1) )
                   END DO
                END DO
@@ -1072,6 +823,6 @@
                DO jj = 2, jpjm1                                   ! T ==> (U,V)
                   DO ji = fs_2, fs_jpim1   ! vector opt.
-                     p_taui(ji,jj) = 0.5 * ( frcv(jpr_itx1)%z3(ji+1,jj  ,1) + frcv(jpr_itx1)%z3(ji,jj,1) )
-                     p_tauj(ji,jj) = 0.5 * ( frcv(jpr_ity1)%z3(ji  ,jj+1,1) + frcv(jpr_ity1)%z3(ji,jj,1) )
+                     p_taui(ji,jj) = 0.5 * ( sf(jp_itx1)%fnow(ji+1,jj  ,1) + sf(jp_itx1)%fnow(ji,jj,1) )
+                     p_tauj(ji,jj) = 0.5 * ( sf(jp_ity1)%fnow(ji  ,jj+1,1) + sf(jp_ity1)%fnow(ji,jj,1) )
                   END DO
                END DO
@@ -1079,10 +830,10 @@
                DO jj = 2, jpjm1                                   ! I ==> (U,V)
                   DO ji = 2, jpim1   ! NO vector opt.
-                     p_taui(ji,jj) = 0.5 * ( frcv(jpr_itx1)%z3(ji+1,jj+1,1) + frcv(jpr_itx1)%z3(ji+1,jj  ,1) )
-                     p_tauj(ji,jj) = 0.5 * ( frcv(jpr_ity1)%z3(ji+1,jj+1,1) + frcv(jpr_ity1)%z3(ji  ,jj+1,1) )
+                     p_taui(ji,jj) = 0.5 * ( sf(jp_itx1)%fnow(ji+1,jj+1,1) + sf(jp_itx1)%fnow(ji+1,jj  ,1) )
+                     p_tauj(ji,jj) = 0.5 * ( sf(jp_ity1)%fnow(ji+1,jj+1,1) + sf(jp_ity1)%fnow(ji  ,jj+1,1) )
                   END DO
                END DO
             END SELECT
-            IF( srcv(jpr_itx1)%clgrid /= 'U' ) THEN 
+            IF( sf(jp_itx1)%clvgrd /= 'U' ) THEN 
                CALL lbc_lnk( p_taui, 'U',  -1. )   ;   CALL lbc_lnk( p_tauj, 'V',  -1. )
             ENDIF
@@ -1163,18 +914,18 @@
       !                                                           ! solid Precipitation                      (sprecip)
       SELECT CASE( TRIM( sn_rcv_emp%cldes ) )
-      CASE( 'conservative'  )   ! received fields: jpr_rain, jpr_snow, jpr_ievp, jpr_tevp
-         sprecip(:,:) = frcv(jpr_snow)%z3(:,:,1)                 ! May need to ensure positive here
-         tprecip(:,:) = frcv(jpr_rain)%z3(:,:,1) + sprecip (:,:) ! May need to ensure positive here
-         emp_tot(:,:) = frcv(jpr_tevp)%z3(:,:,1) - tprecip(:,:)
-         emp_ice(:,:) = frcv(jpr_ievp)%z3(:,:,1) - frcv(jpr_snow)%z3(:,:,1)
-                           CALL iom_put( 'rain'         , frcv(jpr_rain)%z3(:,:,1)              )   ! liquid precipitation 
-         IF( lk_diaar5 )   CALL iom_put( 'hflx_rain_cea', frcv(jpr_rain)%z3(:,:,1) * zcptn(:,:) )   ! heat flux from liq. precip. 
-         ztmp(:,:) = frcv(jpr_tevp)%z3(:,:,1) - frcv(jpr_ievp)%z3(:,:,1) * zicefr(:,:)
+      CASE( 'conservative'  )   ! received fields: jp_rain, jp_snow, jp_ievp, jp_tevp
+         sprecip(:,:) = sf(jp_snow)%fnow(:,:,1)                 ! May need to ensure positive here
+         tprecip(:,:) = sf(jp_rain)%fnow(:,:,1) + sprecip (:,:) ! May need to ensure positive here
+         emp_tot(:,:) = sf(jp_tevp)%fnow(:,:,1) - tprecip(:,:)
+         emp_ice(:,:) = sf(jp_ievp)%fnow(:,:,1) - sf(jp_snow)%fnow(:,:,1)
+                           CALL iom_put( 'rain'         , sf(jp_rain)%fnow(:,:,1)              )   ! liquid precipitation 
+         IF( lk_diaar5 )   CALL iom_put( 'hflx_rain_cea', sf(jp_rain)%fnow(:,:,1) * zcptn(:,:) )   ! heat flux from liq. precip. 
+         ztmp(:,:) = sf(jp_tevp)%fnow(:,:,1) - sf(jp_ievp)%fnow(:,:,1) * zicefr(:,:)
                            CALL iom_put( 'evap_ao_cea'  , ztmp                            )   ! ice-free oce evap (cell average)
          IF( lk_diaar5 )   CALL iom_put( 'hflx_evap_cea', ztmp(:,:         ) * zcptn(:,:) )   ! heat flux from from evap (cell ave)
-      CASE( 'oce and ice'   )   ! received fields: jpr_sbpr, jpr_semp, jpr_oemp, jpr_ievp
-         emp_tot(:,:) = p_frld(:,:) * frcv(jpr_oemp)%z3(:,:,1) + zicefr(:,:) * frcv(jpr_sbpr)%z3(:,:,1)
-         emp_ice(:,:) = frcv(jpr_semp)%z3(:,:,1)
-         sprecip(:,:) = - frcv(jpr_semp)%z3(:,:,1) + frcv(jpr_ievp)%z3(:,:,1)
+      CASE( 'oce and ice'   )   ! received fields: jp_sbpr, jp_semp, jp_oemp, jp_ievp
+         emp_tot(:,:) = p_frld(:,:) * sf(jp_oemp)%fnow(:,:,1) + zicefr(:,:) * sf(jp_sbpr)%fnow(:,:,1)
+         emp_ice(:,:) = sf(jp_semp)%fnow(:,:,1)
+         sprecip(:,:) = - sf(jp_semp)%fnow(:,:,1) + sf(jp_ievp)%fnow(:,:,1)
       END SELECT
 
@@ -1182,15 +933,15 @@
       CALL iom_put( 'snow_ao_cea', sprecip(:,:         ) * p_frld(:,:)    )   ! Snow        over ice-free ocean  (cell average)
       CALL iom_put( 'snow_ai_cea', sprecip(:,:         ) * zicefr(:,:)    )   ! Snow        over sea-ice         (cell average)
-      CALL iom_put( 'subl_ai_cea', frcv(jpr_ievp)%z3(:,:,1) * zicefr(:,:) )   ! Sublimation over sea-ice         (cell average)
+      CALL iom_put( 'subl_ai_cea', sf(jp_ievp)%fnow(:,:,1) * zicefr(:,:) )   ! Sublimation over sea-ice         (cell average)
       !   
       !                                                           ! runoffs and calving (put in emp_tot)
-      IF( srcv(jpr_rnf)%laction ) THEN 
-         emp_tot(:,:) = emp_tot(:,:) - frcv(jpr_rnf)%z3(:,:,1)
-                           CALL iom_put( 'runoffs'      , frcv(jpr_rnf)%z3(:,:,1)              )   ! rivers
-         IF( lk_diaar5 )   CALL iom_put( 'hflx_rnf_cea' , frcv(jpr_rnf)%z3(:,:,1) * zcptn(:,:) )   ! heat flux from rivers
-      ENDIF
-      IF( srcv(jpr_cal)%laction ) THEN 
-         emp_tot(:,:) = emp_tot(:,:) - frcv(jpr_cal)%z3(:,:,1)
-         CALL iom_put( 'calving', frcv(jpr_cal)%z3(:,:,1) )
+      IF( sf(jp_rnf)%loasis ) THEN 
+         emp_tot(:,:) = emp_tot(:,:) - sf(jp_rnf)%fnow(:,:,1)
+                           CALL iom_put( 'runoffs'      , sf(jp_rnf)%fnow(:,:,1)              )   ! rivers
+         IF( lk_diaar5 )   CALL iom_put( 'hflx_rnf_cea' , sf(jp_rnf)%fnow(:,:,1) * zcptn(:,:) )   ! heat flux from rivers
+      ENDIF
+      IF( sf(jp_cal)%loasis ) THEN 
+         emp_tot(:,:) = emp_tot(:,:) - sf(jp_cal)%fnow(:,:,1)
+         CALL iom_put( 'calving', sf(jp_cal)%fnow(:,:,1) )
       ENDIF
       !
@@ -1198,13 +949,13 @@
 !!gm                                       at least should be optional...
 !!       ! remove negative runoff                            ! sum over the global domain
-!!       zcumulpos = SUM( MAX( frcv(jpr_rnf)%z3(:,:,1), 0.e0 ) * e1t(:,:) * e2t(:,:) * tmask_i(:,:) ) 
-!!       zcumulneg = SUM( MIN( frcv(jpr_rnf)%z3(:,:,1), 0.e0 ) * e1t(:,:) * e2t(:,:) * tmask_i(:,:) )
+!!       zcumulpos = SUM( MAX( sf(jp_rnf)%fnow(:,:,1), 0.e0 ) * e1t(:,:) * e2t(:,:) * tmask_i(:,:) ) 
+!!       zcumulneg = SUM( MIN( sf(jp_rnf)%fnow(:,:,1), 0.e0 ) * e1t(:,:) * e2t(:,:) * tmask_i(:,:) )
 !!       IF( lk_mpp )   CALL mpp_sum( zcumulpos )
 !!       IF( lk_mpp )   CALL mpp_sum( zcumulneg ) 
 !!       IF( zcumulpos /= 0. ) THEN                          ! distribute negative runoff on positive runoff grid points
 !!          zcumulneg = 1.e0 + zcumulneg / zcumulpos
-!!          frcv(jpr_rnf)%z3(:,:,1) = MAX( frcv(jpr_rnf)%z3(:,:,1), 0.e0 ) * zcumulneg
+!!          sf(jp_rnf)%fnow(:,:,1) = MAX( sf(jp_rnf)%fnow(:,:,1), 0.e0 ) * zcumulneg
 !!       ENDIF     
-!!       emp_tot(:,:) = emp_tot(:,:) - frcv(jpr_rnf)%z3(:,:,1)   ! add runoff to e-p 
+!!       emp_tot(:,:) = emp_tot(:,:) - sf(jp_rnf)%fnow(:,:,1)   ! add runoff to e-p 
 !!
 !!gm  end of internal cooking
@@ -1214,33 +965,33 @@
       !                                                      ! ========================= !
       CASE( 'oce only' )                                     ! the required field is directly provided
-         qns_tot(:,:  ) = frcv(jpr_qnsoce)%z3(:,:,1)
+         qns_tot(:,:  ) = sf(jp_qnsoce)%fnow(:,:,1)
       CASE( 'conservative' )                                      ! the required fields are directly provided
-         qns_tot(:,:  ) = frcv(jpr_qnsmix)%z3(:,:,1)
+         qns_tot(:,:  ) = sf(jp_qnsmix)%fnow(:,:,1)
          IF ( TRIM(sn_rcv_qns%clcat) == 'yes' ) THEN
-            qns_ice(:,:,1:jpl) = frcv(jpr_qnsice)%z3(:,:,1:jpl)
+            qns_ice(:,:,1:jpl) = sf(jp_qnsice)%fnow(:,:,1:jpl)
          ELSE
             ! Set all category values equal for the moment
             DO jl=1,jpl
-               qns_ice(:,:,jl) = frcv(jpr_qnsice)%z3(:,:,1)
+               qns_ice(:,:,jl) = sf(jp_qnsice)%fnow(:,:,1)
             ENDDO
          ENDIF
       CASE( 'oce and ice' )       ! the total flux is computed from ocean and ice fluxes
-         qns_tot(:,:  ) =  p_frld(:,:) * frcv(jpr_qnsoce)%z3(:,:,1)
+         qns_tot(:,:  ) =  p_frld(:,:) * sf(jp_qnsoce)%fnow(:,:,1)
          IF ( TRIM(sn_rcv_qns%clcat) == 'yes' ) THEN
             DO jl=1,jpl
-               qns_tot(:,:   ) = qns_tot(:,:) + a_i(:,:,jl) * frcv(jpr_qnsice)%z3(:,:,jl)   
-               qns_ice(:,:,jl) = frcv(jpr_qnsice)%z3(:,:,jl)
+               qns_tot(:,:   ) = qns_tot(:,:) + a_i(:,:,jl) * sf(jp_qnsice)%fnow(:,:,jl)   
+               qns_ice(:,:,jl) = sf(jp_qnsice)%fnow(:,:,jl)
             ENDDO
          ELSE
             DO jl=1,jpl
-               qns_tot(:,:   ) = qns_tot(:,:) + zicefr(:,:) * frcv(jpr_qnsice)%z3(:,:,1)
-               qns_ice(:,:,jl) = frcv(jpr_qnsice)%z3(:,:,1)
+               qns_tot(:,:   ) = qns_tot(:,:) + zicefr(:,:) * sf(jp_qnsice)%fnow(:,:,1)
+               qns_ice(:,:,jl) = sf(jp_qnsice)%fnow(:,:,1)
             ENDDO
          ENDIF
       CASE( 'mixed oce-ice' )     ! the ice flux is cumputed from the total flux, the SST and ice informations
 ! ** NEED TO SORT OUT HOW THIS SHOULD WORK IN THE MULTI-CATEGORY CASE - CURRENTLY NOT ALLOWED WHEN INTERFACE INITIALISED **
-         qns_tot(:,:  ) = frcv(jpr_qnsmix)%z3(:,:,1)
-         qns_ice(:,:,1) = frcv(jpr_qnsmix)%z3(:,:,1)    &
-            &            + frcv(jpr_dqnsdt)%z3(:,:,1) * ( pist(:,:,1) - ( (rt0 + psst(:,:  ) ) * p_frld(:,:)   &
+         qns_tot(:,:  ) = sf(jp_qnsmix)%fnow(:,:,1)
+         qns_ice(:,:,1) = sf(jp_qnsmix)%fnow(:,:,1)    &
+            &            + sf(jp_dqnsdt)%fnow(:,:,1) * ( pist(:,:,1) - ( (rt0 + psst(:,:  ) ) * p_frld(:,:)   &
             &                                                   +          pist(:,:,1)   * zicefr(:,:) ) )
       END SELECT
@@ -1259,8 +1010,8 @@
 !! similar job should be done for snow and precipitation temperature
       !                                     
-      IF( srcv(jpr_cal)%laction ) THEN                            ! Iceberg melting 
-         ztmp(:,:) = frcv(jpr_cal)%z3(:,:,1) * lfus               ! add the latent heat of iceberg melting 
+      IF( sf(jp_cal)%loasis ) THEN                            ! Iceberg melting 
+         ztmp(:,:) = sf(jp_cal)%fnow(:,:,1) * lfus               ! add the latent heat of iceberg melting 
          qns_tot(:,:) = qns_tot(:,:) - ztmp(:,:)
-         IF( lk_diaar5 )   CALL iom_put( 'hflx_cal_cea', ztmp + frcv(jpr_cal)%z3(:,:,1) * zcptn(:,:) )   ! heat flux from calving
+         IF( lk_diaar5 )   CALL iom_put( 'hflx_cal_cea', ztmp + sf(jp_cal)%fnow(:,:,1) * zcptn(:,:) )   ! heat flux from calving
       ENDIF
 
@@ -1269,36 +1020,36 @@
       !                                                      ! ========================= !
       CASE( 'oce only' )
-         qsr_tot(:,:  ) = MAX( 0._wp , frcv(jpr_qsroce)%z3(:,:,1) )
+         qsr_tot(:,:  ) = MAX( 0._wp , sf(jp_qsroce)%fnow(:,:,1) )
       CASE( 'conservative' )
-         qsr_tot(:,:  ) = frcv(jpr_qsrmix)%z3(:,:,1)
+         qsr_tot(:,:  ) = sf(jp_qsrmix)%fnow(:,:,1)
          IF ( TRIM(sn_rcv_qsr%clcat) == 'yes' ) THEN
-            qsr_ice(:,:,1:jpl) = frcv(jpr_qsrice)%z3(:,:,1:jpl)
+            qsr_ice(:,:,1:jpl) = sf(jp_qsrice)%fnow(:,:,1:jpl)
          ELSE
             ! Set all category values equal for the moment
             DO jl=1,jpl
-               qsr_ice(:,:,jl) = frcv(jpr_qsrice)%z3(:,:,1)
+               qsr_ice(:,:,jl) = sf(jp_qsrice)%fnow(:,:,1)
             ENDDO
          ENDIF
-         qsr_tot(:,:  ) = frcv(jpr_qsrmix)%z3(:,:,1)
-         qsr_ice(:,:,1) = frcv(jpr_qsrice)%z3(:,:,1)
+         qsr_tot(:,:  ) = sf(jp_qsrmix)%fnow(:,:,1)
+         qsr_ice(:,:,1) = sf(jp_qsrice)%fnow(:,:,1)
       CASE( 'oce and ice' )
-         qsr_tot(:,:  ) =  p_frld(:,:) * frcv(jpr_qsroce)%z3(:,:,1)
+         qsr_tot(:,:  ) =  p_frld(:,:) * sf(jp_qsroce)%fnow(:,:,1)
          IF ( TRIM(sn_rcv_qsr%clcat) == 'yes' ) THEN
             DO jl=1,jpl
-               qsr_tot(:,:   ) = qsr_tot(:,:) + a_i(:,:,jl) * frcv(jpr_qsrice)%z3(:,:,jl)   
-               qsr_ice(:,:,jl) = frcv(jpr_qsrice)%z3(:,:,jl)
+               qsr_tot(:,:   ) = qsr_tot(:,:) + a_i(:,:,jl) * sf(jp_qsrice)%fnow(:,:,jl)   
+               qsr_ice(:,:,jl) = sf(jp_qsrice)%fnow(:,:,jl)
             ENDDO
          ELSE
             DO jl=1,jpl
-               qsr_tot(:,:   ) = qsr_tot(:,:) + zicefr(:,:) * frcv(jpr_qsrice)%z3(:,:,1)
-               qsr_ice(:,:,jl) = frcv(jpr_qsrice)%z3(:,:,1)
+               qsr_tot(:,:   ) = qsr_tot(:,:) + zicefr(:,:) * sf(jp_qsrice)%fnow(:,:,1)
+               qsr_ice(:,:,jl) = sf(jp_qsrice)%fnow(:,:,1)
             ENDDO
          ENDIF
       CASE( 'mixed oce-ice' )
-         qsr_tot(:,:  ) = frcv(jpr_qsrmix)%z3(:,:,1)
+         qsr_tot(:,:  ) = sf(jp_qsrmix)%fnow(:,:,1)
 ! ** NEED TO SORT OUT HOW THIS SHOULD WORK IN THE MULTI-CATEGORY CASE - CURRENTLY NOT ALLOWED WHEN INTERFACE INITIALISED **
 !       Create solar heat flux over ice using incoming solar heat flux and albedos
 !       ( see OASIS3 user guide, 5th edition, p39 )
-         qsr_ice(:,:,1) = frcv(jpr_qsrmix)%z3(:,:,1) * ( 1.- palbi(:,:,1) )   &
+         qsr_ice(:,:,1) = sf(jp_qsrmix)%fnow(:,:,1) * ( 1.- palbi(:,:,1) )   &
             &            / (  1.- ( albedo_oce_mix(:,:  ) * p_frld(:,:)       &
             &                     + palbi         (:,:,1) * zicefr(:,:) ) )
